/**
 * Copyright 2010 Västra Götalandsregionen
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of version 2.1 of the GNU Lesser General Public
 *   License as published by the Free Software Foundation.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 *   Boston, MA 02111-1307  USA
 */

package se.vgregion.appx.cxf;

import org.apache.cxf.Bus;
import org.apache.cxf.bus.spring.SpringBusFactory;
import org.apache.cxf.jaxrs.client.WebClient;

public final class WebClientFactory {

    private WebClientFactory() {
        // not instantiable by other classes
    }

    /**
     * Factory method for creating a {@link WebClient} with an SSL conduit configuration.
     *
     * @param baseAddress the {@link WebClient} will start the URL of its requests with the <code>baseAdress</code>
     * @return the {@link WebClient}
     */
    public static WebClient create(String baseAddress) {
        SpringBusFactory bf = new SpringBusFactory();
        Bus bus = bf.createBus("webclient-conduit-config.xml");
        bf.setDefaultBus(bus);
        return WebClient.create(baseAddress);
    }
}
